= How do I add JUnit tests to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://junit.sourceforge.net/ JUnit] is a simple framework for writing and running automated tests.

== For Maven projects ==
The [http://maven.apache.org/plugins/maven-surefire-plugin/ Surefire] Plugin is a core plug-in for Maven that runs JUnit test.

It can be invoked by calling the `test` phase of the build lifecycle (`mvn test`).

== For Ant builds ==
JUnit is an optional task for Ant that runs JUnit tests.

To use JUnit in an Ant project, add the following file to a directory in your source tree 
(`tools/junit-<%= node['tools']['junit']['version'] %>`):

 * `junit-<%= node['tools']['junit']['version'] %>.jar`

If you prefer to keep the JUnit libraries outside your source tree, change the locations for the `tools.dir` and/or 
the `junit.lib.dir` properties in the lines below.  

Add the following lines to your `build.xml` file. `build.dir`, `classes.dir`, `compile.classpath`,  
`src.dir`, and `test.src.dir` should be set appropriately.

{{{
#!text/xml
	<property name="tools.dir" location="tools"/>
	<property name="junit.lib.dir" location="${tools.dir}/junit<%= node['tools']['junit']['version'] %>"/>

	<property name="report.dir" location="${build.dir}/reports"/>
	<property name="junit.report.dir" location="${report.dir}/junit"/>
	
	<path id="test.classpath">
		<path refid="compile.classpath"/>
		<fileset dir="${junit.lib.dir}" includes="**/*.jar"/>
	</path>
	
	<target name="compile-tests" depends="compile" description="Compiles the test code">
		<mkdir dir="${classes.dir}"/>
		<javac srcdir="${test.src.dir}" destdir="${classes.dir}" includes="**/*.java">
			<classpath refid="test.classpath"/>
		</javac>
	</target>

  <target name="junit" depends="compile-tests" description="Runs JUnit tests">
		<mkdir dir="${junit.report.dir}"/>
		<junit printsummary="true" failureProperty="test.failed">
			<classpath refid="test.classpath"/>
			<formatter type="xml"/>
			<test name="${testcase}" todir="${junit.report.dir}" if="testcase"/>
			<batchtest fork="true" todir="${junit.report.dir}" unless="testcase">
				<fileset dir="${test.src.dir}">
					<include name="**/*Test.java"/>
					<exclude name="**/AllTests.java"/>
				</fileset>
			</batchtest>
		</junit>
	</target>
}}}

The `junit` target will run all the tests (source files in the `test.src.dir` named `*Test.java`) in your project.

To run a single test case, you can pass the fully-qualified class name in the `testcase` property:
{{{
  ant -Dtestcase=com.mycompany.myproject.MySingleTest junit
}}}

To generate a report of test results, add the following lines to `build/xml` and invoke the `junitreport` 
target.

{{{
#!text/xml
	<target name="junitreport" depends="junit" description="Reports on JUnit test results">
		<mkdir dir="${junit.report.dir}"/>
		<junitreport todir="${junit.report.dir}">
			<fileset dir="${junit.report.dir}">
				<include name="*.xml"/>
			</fileset>
			<report format="frames" todir="${junit.report.dir}"/>
		</junitreport>
		
		<property name="junit.report.html" location="${junit.report.dir}/index.html"/>
		<echo message="Test report is at ${junit.report.html}"/>
	</target>
}}}

=== More information ===

 * [http://maven.apache.org/plugins/maven-surefire-plugin/index.html Maven plugin]
 * [http://ant.apache.org/manual/OptionalTasks/junit.html Ant task]

<%= node['trac']['wiki']['footer'] %>